;BASSMOD userlib Abrexxes 2007 
;BASSMOD 2.0 - Copyright (c) 1999-2004 Ian Luck. All rights reserved
;Include this in your project to have flags and help functions

;Error codes returned by BASSMOD_GetErrorCode()
Const BASS_OK% = 0 ;' all is OK
Const BASS_ERROR_MEM% = 1 ;memory error
Const BASS_ERROR_FILEOPEN% = 2 ; can't open the file
Const BASS_ERROR_DRIVER% = 3 ; can't find a free/valid driver
Const BASS_ERROR_HANDLE% = 5 ; invalid handle
Const BASS_ERROR_FORMAT% = 6 ; unsupported format
Const BASS_ERROR_POSITION% = 7 ; invalid playback position
Const BASS_ERROR_INIT% = 8 ; BASS_Init has not been successfully called
Const BASS_ERROR_ALREADY% = 14 ; already initialized/loaded
Const BASS_ERROR_NOPAUSE% = 16 ; not paused
Const BASS_ERROR_ILLTYPE% = 19 ; an illegal type was specified
Const BASS_ERROR_ILLPARAM% = 20 ; an illegal parameter was specified
Const BASS_ERROR_DEVICE% = 23 ; illegal device number
Const BASS_ERROR_NOPLAY% = 24 ; not playing
Const BASS_ERROR_NOMUSIC% = 28 ; no MOD music has been loaded
Const BASS_ERROR_NOSYNC% = 30  ; synchronizers have been disabled
Const BASS_ERROR_NOTAVAIL% = 37 ; requested data is not available
Const BASS_ERROR_DECODE% = 38 ; the channel is a "decoding channel"
Const BASS_ERROR_FILEFORM% = 41 ; unsupported file format
Const BASS_ERROR_UNKNOWN% = -1 ; some other mystery error

; Device setup flags
; Add Values to combine flags
Const BASS_DEVICE_8BITS% = 1 ; use 8 bit resolution, else 16 bit
Const BASS_DEVICE_MONO% = 2 ; use mono, else stereo
Const BASS_DEVICE_NOSYNC% = 16   ;disable synchronizers

; Music flags
; Add Values to combine flags
Const BASS_MUSIC_RAMP% = 1 ; normal ramping
Const BASS_MUSIC_RAMPS% = 2 ; sensitive ramping
Const BASS_MUSIC_LOOP% = 4 ; loop music
Const BASS_MUSIC_FT2MOD% = 16 ; play .MOD as FastTracker 2 does
Const BASS_MUSIC_PT1MOD% = 32 ; play .MOD as ProTracker 1 does
Const BASS_MUSIC_POSRESET% = 256 ; stop all notes when moving position
Const BASS_MUSIC_SURROUND% = 512 ;surround sound
Const BASS_MUSIC_SURROUND2% = 1024 ;surround sound (mode 2)
Const BASS_MUSIC_STOPBACK% = 2048 ;stop the music on a backwards jump effect
Const BASS_MUSIC_CALCLEN%	= 8192 ;calculate playback length
Const BASS_MUSIC_NONINTER% = 16384 ; non-interpolated mixing
Const BASS_MUSIC_NOSAMPLE = $400000 ; don't load the samples
Const BASS_UNICODE% = $80000000

;BASSMOD_MusicIsActive return values
Const BASS_ACTIVE_STOPPED% = 0
Const BASS_ACTIVE_PLAYING% = 1
Const BASS_ACTIVE_PAUSED% = 3

Function BASSMOD_GetDeviceDescriptionString$(device%)
	Local Pointer,BnkDescription,Description$,I,Char
	Pointer = BASSMOD_GetDeviceDescription(device)
	If Not Pointer Then
		Return ""
	Else
		BnkDescription = CreateBank(256)
		BASSMOD_RtlMoveMemory1(BnkDescription,Pointer,256)
		For I = 0 To 255
			Char = PeekByte(BnkDescription,I)
			If Char = 0 Then Exit
			Description$ = Description$ + Chr$(Char)
		Next
	EndIf
	FreeBank BnkDescription : Return Description$
End Function

Function BASSMOD_GetErrorString$()
		Local temp$ = "BASS_CODE_UNKNOWN_BY_FUNCTION"
		Local error%
		error = BASSMOD_ErrorGetCode% ()
		If error = 0 Then temp = "BASS_OK"
		If error = 1 Then temp ="BASS_ERROR_MEM"		
		If error = 2 Then temp ="BASS_ERROR_FILEOPEN"
		If error = 3 Then temp ="BASS_ERROR_DRIVER"				
		If error = 5 Then temp ="BASS_ERROR_HANDLE"		
		If error = 6 Then temp ="BASS_ERROR_FORMAT"		
		If error = 7 Then temp ="BASS_ERROR_POSITION"
		If error = 8 Then temp ="BASS_ERROR_INIT"
		If error = 14 Then temp ="BASS_ERROR_ALREADY"
		If error = 16 Then temp ="BASS_ERROR_NOPAUSE"
		If error = 19 Then temp ="BASS_ERROR_ILLTYPE"
		If error = 20 Then temp ="BASS_ERROR_ILLPARAM" 
		If error = 23 Then temp ="BASS_ERROR_DEVICE" 
		If error = 24 Then temp ="BASS_ERROR_NOPLAY" 
		If error = 28 Then temp ="BASS_ERROR_NOMUSIC" 
		If error = 30 Then temp ="BASS_ERROR_NOSYNC" 
		If error = 37 Then temp ="BASS_ERROR_NOTAVAIL" 
		If error = 38 Then temp ="BASS_ERROR_DECODE" 
		If error = 41 Then temp ="BASS_ERROR_FILEFORM" 
		If error = -1 Then temp ="BASS_ERROR_UNKNOWN" 
		Return temp
End Function 

Function BASSMOD_MakeLong%(lo%,hi%)
	Return (hi Shl 16) Or (lo And $0000FFFF)
End Function

Function BASSMOD_MakeLoWord%(val%)
		Local temp%
		temp = val And $0000FFFF 
		Return temp
End Function

Function BASSMOD_MakeHiWord%(val%)
		Local temp%
		temp = val And $FFFF0000 
		temp = temp Shr 16
		Return temp
End Function 
		

;~IDEal Editor Parameters:
;~C#Blitz3D